/**************************************************************************

			     FANNY Productions (c) 1993

	    Ensemble de rtns graphiques pour Nosco version ATARI MONO
	    *********************************************************

  Auteur / Date :       Gilles Bouthenot	Programmation ASSEMBLEUR.
				Franois SANCHEZ  Programmation C.
				15/11/1993

  Version : 1.1

**************************************************************************/
/*
Bonjour Gilles, voici donc les APPELS des routines ASSEMBLEURS, et comme
tu les a finalement fait a ta sauce, je ne sais pas comment s'appellent
tes routines, mais voici les appels des fonctions en C qui appellent les
routines Assembleurs. Tu notera deux fonctions suplementaires dont une dont
je ne connais pas l'appels car je ne l'ai pas encore recu de la part de
Pierre sur PC,  noter que je ne les ai pas en couleurs sur ST et ne les
aurait pas car je ne pourrait le faire que quand j'en aurait le temps.
Il sagit de (GETPIXEL et de PUTPIXEL) et (GETPIXELM.S et PUTPIXELM.S)
une qui renvoie la couleur (registre d'un point de l'ecran et l'autre qui
affiche un point...). Il y a aussi deux nouvelles fonctions mais dont je
ne peu rien trop te dire, il faut que tu demande a Pierre l aussi car
il sagit de copie_bloc et get_bloc, c'est a dire decouper un bloc dans
un ecran et pouvoir le copier dans un autre. Peut-tu lui demander plus de
prcision l dessus ? Si tu veux bien t'en occuper, bien entendu.

REMARQUE : Les rtns MONO portent le meme nom que les rtn couleur
			avec en suplement un "M" a la fin des rtns
			exemple :
				FPUT.S Couleur	FPUTM.S Mono
				FONDU.S Couleur	FONDUM.S Mono

	Voici les appels en C :

	Mais avant, un message personnel ( a n'en parler  personne car trs
		personnel ) :

	J'ai juste une question  laquelles je souhaiterai sincerement
	que tu me reponde :

		Je voudrai juste savoir si tu m'en veux pour mes erreurs
		passs ? C'est tout ce que je voudrai savoir, il faut
		que tu sache que les choses ne sont pas simples pour moi
		et... Bon j'arrete de raconter ma vie.

		Tu as quand meme mes amitis meme si il se peu que tu ne
		crois pas  une quelconque sympathie de ma part.

		Ces deux lignes que tu viens de lire sont les plus importante
		dans ce fichier, le reste n'est que matriel et la sympathie
		ou l'amitis me semble plus important,  tel point que
		si tu ne me repond qu'a ces deux lignes et que tu ne fait rien
		de ce qui suit dans ce fichier, ce n'est pas grave,
		je considrerai que tu as rpondu au plus important.

			Amitis Francis.

*/


/*	Voici donc les appels en C : */

/* Quelques varibles ou structures ncessaires */
/*ase_ecran est un LONG qui contiens toujours l'adresse de l'ecran de travail*/
long base_ecran;

/* Quelques dfinitions */
typedef unsigned char uchar;
typedef unsigned int ushort;




/* Dfinitions diverses pour la librairie graphique. */
#define OK              0
#define ERREUR          100

#define VRAI            3
#define FAUX            4

#define CONFIG          1
#define RESTORE         2

#define DEHORS		1
#define DEDANS		2
#define CHEVAL		3





typedef struct {
	char rouge;             /* Intensit de rouge (<64) */
	char vert;              /* Intensit de rouge (<64) */
	char bleu;              /* Intensit de rouge (<64) */
	} COULEUR;

typedef struct {
	int y;                  /* Abcisse du pixel */
	int x;                  /* Ordonne du pixel */
	int couleur;           /* couleur du pixel */
	} PIXEL;

/* Demande  Pierre pour la dfinition de la structure qui suit */
typedef struct {
	ushort freq;		/* frquence de restitution */
	char mode;			/* mode : NORMAL ou REPETITION */
	ushort nbre;		/* nbre d'chantillons du sample */
	ushort pos;			/* position joue dans le sample */
	uchar *volume;		/* volume du sample */
	ushort acc;			/* accumulateur */
	char etat;			/* LANCE, MARCHE, ARRET ou STOP */
	uchar *ps_mem;		/* pointeur sur la zone mmoire du sample */
	} SAMPLE;


/***************************************************************************
				LA LIBRAIRIE GRAPHIQUE.
***************************************************************************/
#define ARRET 		0
#define STOP            1
#define LANCE           2
#define MARCHE          3
#define REPETITION	4
#define MONO		5


/* Liste des fonctions de GFXLIB.C */
/**********************************/
copie_bloc ????????????? <-----Demande  Pierre si tu veux le faire en couleur
	et monochrome (je ne t'oblige pas du tout  le faire c'est toi qui
	dcide


get_bloc   ????????????? <-----Demande  Pierre si tu veux Mono et couleur


/* Lecture d'un pixel dans la page en cours */
char get_pixel(int x , int y , long adresse); <-----Demande  Pierre si tu
						veux. (Mono et couleur)



/* Efface l'cran en cours en le mettant  la couleur de son choix */
char cls(char couleur);
/* Ecriture d'un pixel dans la page en cours */
char put_pixel(int x , int y , char couleur);
/* Trac d'une ligne verticale */
char vline(int yt , int yb , int x , char couleur);
/* Trac d'une ligne horizontale */
char hline(int xt , int xb , int y , char couleur);
/* Trac d'une boite rectangulaire pleine */
char pbox(int xt ,  int yt , int xb ,int yb, char couleur);
/* Ecriture d'un ensemble de pixels dans la page en cours */
char nuage(PIXEL *tab , int n);
/* Lecture d'un pixel dans la page en cours */
char fget(int xt , int yt , int hauteur , int largeur , char *buff);
/* Place un sprite dans l'cran de travail (avec clipping), la fonction
fput_mask est identique quant aux appels*/
char fput(int xt , int yt , int hauteur , int largeur , char *buff,
	  int xtc , int ytc , int xbc , int ybc);
/* Place un sprite (masque) dans l'cran de travail (avec clipping) */
char fput_mask(int xt , int yt , int hauteur , int largeur , char *buff,
	  int xtc , int ytc , int xbc , int ybc);
/* Ralise un fondu entre deux crans */
char fondu(char ecran);


/************************
 * Dtail des fonctions *
 ************************/
/**************************************************************************

/**************************************************************************
  Procdure : cls

  Fonction : efface l'cran de travail en le mettant  la couleur
		spcifie.

	     L'effacement de l'cran n'est pas synchronis avec la VBL.

  Entres : couleur = couleur de l'effacement (entre 0 et 15)

  Sorties  : OK ou ERREUR si :
		- la couleur n'est pas comprise entre 0 et 15
**************************************************************************/
/**************************************************************************

  Procdure : put_pixel

  Fonction : affiche un point dans l'cran de travail.

  Entres : x = abcisse du point (entre 0 et 319)
	    y = ordonne du point (entre 0 et 199)
	    couleur = couleur du pixel (entre 0 et 15)

  Sorties  : OK ou ERREUR si :
		- l'abcisse sort de 0-319
		- l'ordonne sort de 0-199
		- la couleur sort de 0-15
**************************************************************************/
/**************************************************************************

  Procdure : vline

  Fonction : trace une ligne verticale dans l'cran de travail.

  Entres : yt = ordonne de l'extrmit suprieure de la ligne (entre 0 et
		199)
	    yb = ordonne de l'extrmit infrieure de la ligne (entre 0 et
		199)
	    x = abcisse de la ligne (entre 0 et 319)
	    couleur = couleur de la ligne

  Sorties  : OK ou ERREUR si :
		- yt n'est pas dans l'intervalle 0-199
		- yb n'est pas dans l'intervalle 0-199
		- x n'est pas dans l'intervalle 0-319
		- couleur n'est pas dans l'intervalle 0-15

		yt >= yb n'est pas une erreur.

**************************************************************************/
/**************************************************************************

  Procdure : hline

  Fonction : trace une ligne horizontale dans l'cran de travail.

  Entres : xt = abcisse de l'extrmit gauche de la ligne (entre 0 et 319)
	    xb = abcisse de l'extrmit droite de la ligne (entre 0 et 319)
	    y = ordonne de la ligne (entre 0 et 199)
	    couleur = couleur de la ligne

  Sorties  : OK ou ERREUR si :
		- xt n'est pas dans l'intervalle 0-319
		- xb n'est pas dans l'intervalle 0-319
		- y n'est pas dans l'intervalle 0-199
		- couleur n'est pas dans l'intervalle 0-15

		xt >= xb n'est pas une erreur.
**************************************************************************/
/**************************************************************************

  Procdure : pbox

  Fonction : trace une boite rectangulaire pleine dans l'cran de travail.

  Entres : xt = abcisse de l'extrmit gauche de la boite (entre 0 et 319)
	    xb = abcisse de l'extrmit droite de la boite (entre 0 et 319)
	    yt = ordonne du cot suprieur de la boite (entre 0 et 199)
	    yb = ordonne du cot infrieur de la boite (entre 0 et 199)
	    couleur = couleur de la boite
			> 0 = BLANC
			= 0 = NOIR

  Sorties  : OK ou ERREUR si :
		- xt n'est pas dans l'intervalle 0-319
		- xb n'est pas dans l'intervalle 0-319
		- yt n'est pas dans l'intervalle 0-199
		- yb n'est pas dans l'intervalle 0-199
		- couleur n'est pas dans l'intervalle 0-15

		xt >= xb n'est pas une erreur.
		yt >= yb n'est pas une erreur.

**************************************************************************/
/**************************************************************************

  Procdure : nuage

  Fonction : affiche un ensemble de points dans l'cran de travail.

  Entres : tab = tableau de structures PIXEL contenant les
		  points  afficher. Les coordonnes et les couleurs
		  des pixels ne sont pas testes pour des raison de vitesse.

	    n = nombre de points  afficher (nombre strictement positif)

  Sorties  : OK ou ERREUR si :
		- n <= 0
**************************************************************************/
/**************************************************************************

  Procdure : fget

  Fonction : extrait un sprite de l'cran de travail.
		La taille du buffer doit donc tre au minimum de :
		 hauteur * largeur /2

		La largeur du sprite doit tre un multiple de 16
		L'abcisse du coin haut gauche du sprite doit tre align sur
		un bloc de 16.


  Entres :  xt = abcisse du coin haut gauche du sprite dans l'cran
	     yt = ordonne du coin haut gauche du sprite dans l'cran
	     hauteur = hauteur du sprite
	     largeur = largeur du sprite (multiple de 16)

  Sorties  : OK ou ERREUR si :
		- xt n'est pas dans l'intervalle 0-319
		- yt n'est pas dans l'intervalle 0-199
		- la largeur et la hauteur est nulle
		- le sprite sort de l'cran

**************************************************************************/
/**************************************************************************
  Procdure : fput

  Fonction : affiche un sprite dans l'cran de travail.
		Le sprite est clipp dans un rectangle, l'affichage est
		effectu dans le rectangle, bords du rectangle inclus.
	     Le sprite est lu dans un buffer cre par fget().

  Entres :  xt = abscisse du coin haut gauche du sprite dans l'cran
	     yt = ordonne du coin haut gauche du sprite dans l'cran
	     hauteur = hauteur du sprite
	     largeur = largeur du sprite (multiple de 16)
	     buff = buffer o est stock le sprite (au format cr par fget())
	     xtc = abscisse du coin haut gauche du rectangle de clipping
	     ytc = ordonne du coin haut gauche du rectangle de clipping
	     xbc = abscisse du coin bas droit du rectangle de clipping
	     ybc = ordonne du coin bas droit du rectangle de clipping

  Sorties  : DEDANS si le sprite est intgralement dans le rectangle
		de clipping
	     CHEVAL si le sprite est clipp dans le rectangle
	     DEHORS si le sprite est intgralement hors du rectangle
**************************************************************************/
/**************************************************************************
  Procdure : fput_mask

  Fonction : affiche un sprite dans l'cran de travail.
		Le sprite est clipp dans un rectangle, l'affichage est
		effectu dans le rectangle, bords du rectangle inclus.
	     Le sprite est lu dans un buffer cre par fget().

  Entres :  xt = abscisse du coin haut gauche du sprite dans l'cran
	     yt = ordonne du coin haut gauche du sprite dans l'cran
	     hauteur = hauteur du sprite
	     largeur = largeur du sprite (multiple de 16)
	     buff = buffer o est stock le sprite (au format cr par fget())
	     xtc = abscisse du coin haut gauche du rectangle de clipping
	     ytc = ordonne du coin haut gauche du rectangle de clipping
	     xbc = abscisse du coin bas droit du rectangle de clipping
	     ybc = ordonne du coin bas droit du rectangle de clipping

  Sorties  : DEDANS si le sprite est intgralement dans le rectangle
		de clipping
	     CHEVAL si le sprite est clipp dans le rectangle
	     DEHORS si le sprite est intgralement hors du rectangle
**************************************************************************/

/**************************************************************************

  Procdure : fondu

  Fonction : ralise un fondu entre deux crans (en passant d'une image
		 une autre par blocs )
	     On mixe l'cran source avec l'cran de travail, le rsultat est
		l'cran de travail.
	     L'cran source n'est pas modifi.

	     gnrateur de Lehmer souhait : x= (x*3141 + 1) mod 8192

  Entres :  ecran = ecran source du fondu

  Sorties  : OK ou ERREUR si :
		- le numro de l'cran n'existe pas

**************************************************************************/
