/***************************************************************************
   FANNY Productions (c)1993.
	Date	20/11/93.

	OBJET :
		Fichier des appels des routines assembleurs monochromes version
	ATARI pour Gilles Bouthenot de la part de Franois Sanchez.

     IMPORTANT :
     *******************************************************************
     * Recherches la squence "ASM" pour voir le passage de parametres *
     * aux travers des structures et les appels des routines.          *
     *******************************************************************

	P.S.:
	Pour getpixel et putpixel (si tu as dcid de le faire )
	le passage de parametres est :
		Pour get_pixel.
			.L ecran
			.W x
			.W y
			.L adresse de stokage de la valeur retourn.

		Pour put_pixel.
			.L ecran
			.W x
			.W y
			.W couleur  afficher.

	Bon courage pour la suite de NOSCO, tiens au fait, je t'ai prpar
	un courrier aujourd'hui avec deux disks, ils partiront au plus tard
	lundi matin. Il y a dedans entre autres chose, Lasermen qui a mon avis
	devrait te plaire. Quand le jeu sera fait avec le DSP (enfin j'espere)
	il risque fort de degager un maximum mais pour le moment je le trouve
	relativement lent. Enfin ce n'est que mon avis. Mais pour ce qui est
	des graphismes, ils me plaisent beaucoup.

				Mes amitis Francis.


				C'est partit.

/**************************************************************************
 * 				LES STRUCTURES						  *
 **************************************************************************/
typedef struct
{
	unsigned long adrscr;	/* Adresse de l'cran                   */
	unsigned int x1;		/* coordonnes. Elles peuvent           */
	unsigned int y1;		/* tre inverses !                     */
	unsigned int x2;		/* "                                    */
	unsigned int y2;		/* "                                    */
	unsigned int coul;	/* numro de la couleur (entre 0 et 15) */
} S_GRAFX;
/****************************************************************************/
typedef struct
{
	unsigned 	long Nbrpix;	/* Nombre de pixels     */
	unsigned	long destination;	/* Adresse de l'ecran   */
	unsigned	long Adrsrc;	/* Adresse de la source */
} S_FONDU;
/****************************************************************************/
typedef struct {
	char rouge;             /* Intensit de rouge (<8) */
	char vert;              /* Intensit de rouge (<8) */
	char bleu;              /* Intensit de rouge (<8) */
	} COULEUR;
/****************************************************************************/
typedef struct {
	int 	y;                  /* Abcisse du pixel */
	int 	x;                  /* Ordonne du pixel */
	int	couleur;           /* couleur du pixel */
	} PIXEL;
/****************************************************************************/
typedef struct
{
	long adrscr;	/* Adresse de l'ecran  */
	PIXEL *adrpts;	/* Adresse de la table de points */
	int  nbrpts;	/* Nombre de points entre 0 et 65535 */
} Nuage;
/****************************************************************************/
			/**********************************************
			 * Les dclarations des routines assembleurs  *
			 **********************************************/
void		VLINEM(long paramametre);
void		HLINEM(long parametre);
void		FGETM(long parametre);
void		FONDUM(long parametre);
void		PBOXM(long paramametre);
void		FPUTM(long tab_clip,long tab_sprite,long ecran);
void		FPUTMASQ(long tab_clip,long tab_sprite,long ecran);
/*REMARQUE : Pour FPUTMASQ, tu dois prendre les memes parametres que pour
			FPUTM.*/
void		NUAGEM(long param);
/************************************************************************
 * LES FONCTIONS AVEC LES APPELS DES ROUTINES ASSEMBLEURS ET LE PASSAGE *
 *				DES PARAMETRES                                  *
 ************************************************************************/
char vline(int y1,int y2,int x,char coul)
{
	S_GRAFX param;
	/* Vrification des coordonnes et couleur */
	if ((coul<0) || (coul>15)
		|| (x<0) || (x>319)
		|| (y1<0) || (y1>199)
		|| (y2<0) || (y2>199))
		return ERREUR;
/*ASM*/	/* mise en place des parametres */
	param.x1		=	x;
	param.y1		=	y1;
	param.y2		=	y2;
	param.coul		=	coul;
	param.adrscr	=	base_ecran;
	/* Appel de la routine ASM. */
	VLINEM((long)&param);
	return OK;
}

char hline(int x1,int x2,int y,char coul)
{
	S_GRAFX param;
	/* Vrification des coordonnes et couleur */
	if ((coul<0) || (coul>15)
		|| (x1<0) || (x1>319)
		|| (x2<0) || (x2>319)
		|| (y<0) || (y>199))
		return ERREUR;

/*ASM*//* mise en place des parametres */
	param.x1=x1;
	param.x2=x2;
	param.y1=y;
	param.coul=coul;
	param.adrscr=base_ecran;
	/* trace la ligne horizontale */
	HLINEM((long)&param);
	return OK;
}
char fget(int xt , int yt , int hauteur , int largeur , char *buff)
{
	Fget p;

	/* Sur ATARI il faut des multiples de 16 en largeur pour etre plus
	rapide . Donc on modifie la largeur si ce n'est pas multiple
	de 16 et comme sur PC on fait des multiples de 8, il suffit de rajouter
	8, pour etre multiple de 16. Pour rester compatible avec la librairie
	PC... enfin le plus possible.*/

	if ((largeur%16) !=0)
		largeur+=8;
/*ASM*/
	p.destination	= base_ecran;
	p.x			= xt;
	p.y			= yt;
	p.larg		= largeur;
	p.haut		= hauteur;
	p.stockage		= buff;
	p.plan		= 15;
	p.mode		= 0;
	FGETM((long)&p);

	return(OK);
}
char fondu(char ecran)
{
	S_FONDU	p;
	if ((ecran < 0) || (ecran > 3))
		return ERREUR;

/*ASM*/
	p.Nbrpix=64000UL;  		 /* Nombre de pixels a afficher 	*/
	p.destination=base_ecran; 	 /* Ecran destination 			*/
	p.Adrsrc=adresse_ecran[ecran]; /* Ecran source 				*/
	FONDUM((long)&p);
	return OK;
}
char pbox(int x1 ,  int y1 , int x2 ,int y2, char coul)
{
	S_GRAFX	param;

	/* Vrification des coordonnes */
	if ((coul<0) || (coul>15)
		|| (x1<0) || (x1>319)
		|| (x2<0) || (x2>319)
		|| (y1<0) || (y1>199)
		|| (y2<0) || (y2>199))
		return ERREUR;

/*ASM*/	/* mise en place des parametres */
	param.x1=x1;
	param.x2=x2;
	param.y1=y1;
	param.y2=y2;
	param.coul=coul;
	param.adrscr=base_ecran;

	/* Appel de la routine ASM. */
	PBOXM((long)&param);
	return OK;
}

char fput(int xt , int yt , int hauteur , int largeur , char *buff,
	  int xtc , int ytc , int xbc , int ybc)
{
int  clip[4];
long  sprite[8];
	if ((largeur%16) !=0)
		largeur+=8;
/*ASM*/
	clip[0]=xtc;
	clip[1]=xbc;
	clip[2]=ytc;
	clip[3]=ybc;
	sprite[0]=(long)xt;
	sprite[1]=(long)yt;
	sprite[2]=(long)hauteur;
	sprite[3]=(long)largeur;
	sprite[4]=15L;
	sprite[5]=0L;
	sprite[6]=(long)buff;
	sprite[7]=0;
	FPUTM((long)&clip[0],(long)&sprite[0],base_ecran);
	return(OK);
}
char nuage(PIXEL *tab , int n)
{
	Nuage param;
/*ASM*/
	param.adrscr=base_ecran;
	param.adrpts=tab;
	param.nbrpts=n;
	NUAGEM((long)&param);
	return OK;
}
